using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.XlsIO;
using System.Data;
using System.Data.OleDb;


namespace EssentialXlsIOSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnImport;
		private System.Windows.Forms.Button btnExport;
		private System.Windows.Forms.Label label1;
	
		//private System.Data.
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnImport = new System.Windows.Forms.Button();
			this.btnExport = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// btnImport
			// 
			this.btnImport.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnImport.Location = new System.Drawing.Point(32, 48);
			this.btnImport.Name = "btnImport";
			this.btnImport.Size = new System.Drawing.Size(120, 32);
			this.btnImport.TabIndex = 0;
			this.btnImport.Text = "CreateDataValidation";
			this.btnImport.Click += new System.EventHandler(this.btnImport_Click);
			// 
			// btnExport
			// 
			this.btnExport.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnExport.Location = new System.Drawing.Point(216, 48);
			this.btnExport.Name = "btnExport";
			this.btnExport.Size = new System.Drawing.Size(112, 32);
			this.btnExport.TabIndex = 1;
			this.btnExport.Text = "ImportingDatabase";
			this.btnExport.Click += new System.EventHandler(this.btnExport_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 120);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(312, 48);
			this.label1.TabIndex = 2;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(368, 206);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.btnExport);
			this.Controls.Add(this.btnImport);
			this.Name = "Form1";
			this.Text = "Essential XlsIO Samples";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		
		private void CreateDataValidation(IWorksheet sheet)
		{
			//Data validation to list the values in the first cell
			IDataValidation validation = sheet.Range["A1"].DataValidation;
			sheet.Range["A1"].Text = "Import from Database";
			validation.ListOfValues = new string[] {"Yes","No"};
			validation.PromptBoxText = "Import from Database";
			validation.IsPromptBoxVisible = true;
			validation.ShowPromptBox = true;     
      
			//Data validation to list the values in the first cell
			IDataValidation validation1 = sheet.Range["A4"].DataValidation;
			sheet.Range["A4"].Text = "Importing List";
			validation1.ListOfValues = new string[] {"Customer","Products"};
			validation1.PromptBoxText = "Importing List";
			validation1.IsPromptBoxVisible = true;
			validation1.ShowPromptBox = true;     
			
		}
		private void btnImport_Click(object sender, System.EventArgs e)
		{
			label1.Text="Please click this first to create excel file having data validation prompt box and save the file after editing";
			ExcelEngine excelEngine = new ExcelEngine();			
			IApplication application = excelEngine.Excel;			
			IWorkbook workbook = application.Workbooks.Create(3);	
			IWorksheet sheet = workbook.Worksheets[0];

			CreateDataValidation(sheet);
			
			workbook.SaveAs("../../Data/Sample.xls");
			workbook.Close();
			
				System.Diagnostics.Process.Start(System.IO.Path.GetFullPath("../../Data/Sample.xls"));
				

		
		}

		private void ImportData(IWorksheet sheet,string CommandString )
		{
			string ConnectionString = "provider=Microsoft.Jet.OLEDB.4.0;"+ @"Data Source= ../../Data/Northwind.mdb"; 
			// = @"SELECT Name, Products.ProductName,Products.QuantityPerUnit,Products.UnitsInStock FROM Categories INNER JOIN Products ON Categories.CategoryID = Products.CategoryID  ORDER BY  Products.ProductName,Categories.CategoryName";
			OleDbDataAdapter DataAdapter=new OleDbDataAdapter(CommandString,ConnectionString);
			DataSet dset = new DataSet();
			DataAdapter.Fill(dset,"Categories");
			DataTable dTable=dset.Tables[0];
			sheet.ImportDataTable(dTable,false,8,1);

		}
		private void btnExport_Click(object sender, System.EventArgs e)
		{
			label1.Text="create excel file importing database";
			
			ExcelEngine excelEngine = new ExcelEngine();			
			IApplication application = excelEngine.Excel;			
			IWorkbook workbook = application.Workbooks.Open(@"../../Data/Sample.xls");	
			IWorksheet sheet = workbook.Worksheets[0];
			if(sheet.Range["A1"].Text=="Yes")
			{
				string str=sheet.Range["A4"].Text;
				switch(str)
				{
					case "Customer":
					{
						str="SELECT CompanyName FROM " +
							"Customers";
						
						ImportData(sheet,str);
						sheet.Range["A6"].Text="You have now imported company name of customers";
						break;
					}
					case "Products":
					{
						str="SELECT CompanyName FROM " +
							"Customers";
						
						ImportData(sheet,str);
						sheet.Range["A6"].Text="You have now imported Company name of products";
						break;
					}
					default:
					{
					sheet.Range["A6"].Text="You have chosen nothing from the list";
						break;
					}
				}
			
			}
			else
			{
			MessageBox.Show("You have entered no in the sheet");
			}
			workbook.Save();
			workbook.Close();
			System.Diagnostics.Process.Start(System.IO.Path.GetFullPath("../../Data/Sample.xls"));				

		}

	}
}

